# Tools ## List tools `tool_sets.tools.list(tool_set_id, **kwargs) -> CursorPagination` **get** `/v1/workspaces/{workspaceId}/tool_sets/{toolSetId}/tools` Lists all tools in the tool set ### Parameters - `workspace_id: String` - `tool_set_id: String` - `bundle_key: String` Filter by bundle_key — return only resources owned by this bundle. - `cursor: String` Pagination cursor from previous response - `include_info: bool` When set to true you may use more of your alloted API rate-limit - `limit: Integer` Maximum number of results to return - `names: Array[String]` Filter by tool name (exact match). Multiple values are OR'd together. - `prefix: String` Filter expression (query param: prefix) - `query: String` Free-form search query - `requires_approval: bool` Filter by approval requirement. Omitted = no filter; true = only tools requiring approval; false = only tools not requiring approval. - `sort_order: String` Sort order for results (asc or desc by creation time) - `statuses: Array[:TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED]` Filter by tool status. Multiple values are OR'd together. - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` ### Returns - `class Tool` - `metadata: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `info: ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) ### Example ```ruby require "cadenya" cadenya = Cadenya::Client.new(api_key: "My API Key") page = cadenya.tool_sets.tools.list("toolSetId", workspace_id: "workspaceId") puts(page) ``` #### Response ```json { "items": [ { "metadata": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "config": { "http": { "requestMethod": "HTTP_METHOD_UNSPECIFIED", "headers": { "foo": "string" }, "path": "path", "query": "query", "requestBodyContentType": "requestBodyContentType", "requestBodyTemplate": "requestBodyTemplate", "toolName": "toolName" }, "mcp": { "toolDescription": "toolDescription", "toolName": "toolName", "toolTitle": "toolTitle" }, "openapi": { "method": "method", "operationId": "operationId", "path": "path" } }, "description": "description", "parameters": { "foo": "bar" }, "status": "TOOL_STATUS_UNSPECIFIED", "requiresApproval": true }, "info": { "createdBy": { "metadata": { "id": "id", "accountId": "accountId", "name": "name", "profileId": "profileId", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "type": "PROFILE_TYPE_UNSPECIFIED", "email": "email", "name": "name" } }, "toolSet": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } } } } ], "pagination": { "nextCursor": "nextCursor", "total": 0 } } ``` ## Create a new tool `tool_sets.tools.create(tool_set_id, **kwargs) -> Tool` **post** `/v1/workspaces/{workspaceId}/tool_sets/{toolSetId}/tools` Creates a new tool in the tool set ### Parameters - `workspace_id: String` - `tool_set_id: String` - `metadata: CreateResourceMetadata` CreateResourceMetadata contains the user-provided fields for creating a workspace-scoped resource. Read-only fields (id, account_id, workspace_id, profile_id, created_at) are excluded since they are set by the server. - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") - `bundle_key: String` Optional bundle ownership key. See ResourceMetadata.bundle_key. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` ### Returns - `class Tool` - `metadata: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `info: ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) ### Example ```ruby require "cadenya" cadenya = Cadenya::Client.new(api_key: "My API Key") tool = cadenya.tool_sets.tools.create( "toolSetId", workspace_id: "workspaceId", metadata: {name: "name"}, spec: {config: {}, description: "description", parameters: {foo: "bar"}, status: :TOOL_STATUS_UNSPECIFIED} ) puts(tool) ``` #### Response ```json { "metadata": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "config": { "http": { "requestMethod": "HTTP_METHOD_UNSPECIFIED", "headers": { "foo": "string" }, "path": "path", "query": "query", "requestBodyContentType": "requestBodyContentType", "requestBodyTemplate": "requestBodyTemplate", "toolName": "toolName" }, "mcp": { "toolDescription": "toolDescription", "toolName": "toolName", "toolTitle": "toolTitle" }, "openapi": { "method": "method", "operationId": "operationId", "path": "path" } }, "description": "description", "parameters": { "foo": "bar" }, "status": "TOOL_STATUS_UNSPECIFIED", "requiresApproval": true }, "info": { "createdBy": { "metadata": { "id": "id", "accountId": "accountId", "name": "name", "profileId": "profileId", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "type": "PROFILE_TYPE_UNSPECIFIED", "email": "email", "name": "name" } }, "toolSet": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } } } } ``` ## Get a tool by ID `tool_sets.tools.retrieve(id, **kwargs) -> Tool` **get** `/v1/workspaces/{workspaceId}/tool_sets/{toolSetId}/tools/{id}` Retrieves a tool by ID from the workspace ### Parameters - `workspace_id: String` - `tool_set_id: String` - `id: String` ### Returns - `class Tool` - `metadata: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `info: ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) ### Example ```ruby require "cadenya" cadenya = Cadenya::Client.new(api_key: "My API Key") tool = cadenya.tool_sets.tools.retrieve("id", workspace_id: "workspaceId", tool_set_id: "toolSetId") puts(tool) ``` #### Response ```json { "metadata": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "config": { "http": { "requestMethod": "HTTP_METHOD_UNSPECIFIED", "headers": { "foo": "string" }, "path": "path", "query": "query", "requestBodyContentType": "requestBodyContentType", "requestBodyTemplate": "requestBodyTemplate", "toolName": "toolName" }, "mcp": { "toolDescription": "toolDescription", "toolName": "toolName", "toolTitle": "toolTitle" }, "openapi": { "method": "method", "operationId": "operationId", "path": "path" } }, "description": "description", "parameters": { "foo": "bar" }, "status": "TOOL_STATUS_UNSPECIFIED", "requiresApproval": true }, "info": { "createdBy": { "metadata": { "id": "id", "accountId": "accountId", "name": "name", "profileId": "profileId", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "type": "PROFILE_TYPE_UNSPECIFIED", "email": "email", "name": "name" } }, "toolSet": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } } } } ``` ## Update a tool `tool_sets.tools.update(id, **kwargs) -> Tool` **put** `/v1/workspaces/{workspaceId}/tool_sets/{toolSetId}/tools/{id}` Updates a tool in the tool set ### Parameters - `workspace_id: String` - `tool_set_id: String` - `id: String` - `metadata: UpdateResourceMetadata` UpdateResourceMetadata contains the user-provided fields for updating a workspace-scoped resource. Read-only fields (id, account_id, workspace_id, profile_id, created_at) are excluded since they are set by the server. - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") - `bundle_key: String` Optional bundle ownership key. See ResourceMetadata.bundle_key. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `update_mask: String` ### Returns - `class Tool` - `metadata: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `info: ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) ### Example ```ruby require "cadenya" cadenya = Cadenya::Client.new(api_key: "My API Key") tool = cadenya.tool_sets.tools.update("id", workspace_id: "workspaceId", tool_set_id: "toolSetId") puts(tool) ``` #### Response ```json { "metadata": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "config": { "http": { "requestMethod": "HTTP_METHOD_UNSPECIFIED", "headers": { "foo": "string" }, "path": "path", "query": "query", "requestBodyContentType": "requestBodyContentType", "requestBodyTemplate": "requestBodyTemplate", "toolName": "toolName" }, "mcp": { "toolDescription": "toolDescription", "toolName": "toolName", "toolTitle": "toolTitle" }, "openapi": { "method": "method", "operationId": "operationId", "path": "path" } }, "description": "description", "parameters": { "foo": "bar" }, "status": "TOOL_STATUS_UNSPECIFIED", "requiresApproval": true }, "info": { "createdBy": { "metadata": { "id": "id", "accountId": "accountId", "name": "name", "profileId": "profileId", "externalId": "externalId", "labels": { "foo": "string" } }, "spec": { "type": "PROFILE_TYPE_UNSPECIFIED", "email": "email", "name": "name" } }, "toolSet": { "id": "id", "accountId": "accountId", "createdAt": "2019-12-27T18:11:19.117Z", "name": "name", "profileId": "profileId", "workspaceId": "workspaceId", "bundleKey": "bundleKey", "externalId": "externalId", "labels": { "foo": "string" } } } } ``` ## Delete a tool `tool_sets.tools.delete(id, **kwargs) -> void` **delete** `/v1/workspaces/{workspaceId}/tool_sets/{toolSetId}/tools/{id}` Deletes a tool in the tool set ### Parameters - `workspace_id: String` - `tool_set_id: String` - `id: String` ### Example ```ruby require "cadenya" cadenya = Cadenya::Client.new(api_key: "My API Key") result = cadenya.tool_sets.tools.delete("id", workspace_id: "workspaceId", tool_set_id: "toolSetId") puts(result) ``` ## Domain Types ### Config HTTP - `class ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. ### Config Mcp - `class ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` ### Config OpenAPI - `class ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` ### Tool - `class Tool` - `metadata: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` - `info: ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) ### Tool Info - `class ToolInfo` - `created_by: Profile` A profile identifies a user or non-human principal (such as an API key) at the account level. Profiles are account-scoped and can be granted access to multiple workspaces. - `metadata: AccountResourceMetadata` AccountResourceMetadata is used to represent a resource that is associated to an account but not to a workspace. - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "apikey_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} - `spec: ProfileSpec` Configuration for a profile. - `type: :PROFILE_TYPE_UNSPECIFIED | :PROFILE_TYPE_USER | :PROFILE_TYPE_API_KEY | :PROFILE_TYPE_SYSTEM` Whether this profile represents a human user, an API key, or a system principal. - `:PROFILE_TYPE_UNSPECIFIED` - `:PROFILE_TYPE_USER` - `:PROFILE_TYPE_API_KEY` - `:PROFILE_TYPE_SYSTEM` - `email: String` Email address of the profile. Required and unique within an account for user profiles. - `name: String` Display name (e.g., "Bobby Tables"). - `tool_set: ResourceMetadata` Standard metadata for persistent, named resources (e.g., agents, tools, prompts) - `id: String` Unique identifier for the resource (prefixed ULID, e.g., "agent_01HXK...") - `account_id: String` Account this resource belongs to for multi-tenant isolation (prefixed ULID) - `created_at: Time` Timestamp when this resource was created - `name: String` Human-readable name for the resource (e.g., "Customer Support Agent", "Email Tool") Required for resources that users interact with directly - `profile_id: String` ID of the actor (user or service account) that created this resource - `workspace_id: String` Workspace this resource belongs to for organizational grouping (prefixed ULID) - `bundle_key: String` Optional bundle ownership key. When set, indicates the resource is managed by a configuration bundle identified by this key. Used by BulkWorkspaceResources.Apply to track which resources belong to which bundle for reconciliation / soft-delete on re-apply. - `external_id: String` External ID for the resource (e.g., a workflow ID from an external system) - `labels: Hash[Symbol, String]` Arbitrary key-value pairs for categorization and filtering Examples: {"environment": "production", "team": "platform", "version": "v2"} ### Tool Spec - `class ToolSpec` - `config: ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String` - `description: String` - `parameters: Hash[Symbol, untyped]` - `status: :TOOL_STATUS_UNSPECIFIED | :TOOL_STATUS_AVAILABLE | :TOOL_STATUS_OMITTED | :TOOL_STATUS_ARCHIVED` - `:TOOL_STATUS_UNSPECIFIED` - `:TOOL_STATUS_AVAILABLE` - `:TOOL_STATUS_OMITTED` - `:TOOL_STATUS_ARCHIVED` - `requires_approval: bool` ### Tool Spec Config - `class ToolSpecConfig` Config defines the adapter to use for the tool. This is used to determine how the tool is called. For example, if the tool is an HTTP tool, the adapter will be Http. If the tool is an inline tool, the adapter will be Inline. - `http: ConfigHTTP` - `request_method: :HTTP_METHOD_UNSPECIFIED | :GET | :POST | 3 more` - `:HTTP_METHOD_UNSPECIFIED` - `:GET` - `:POST` - `:PUT` - `:PATCH` - `:DELETE` - `headers: Hash[Symbol, String]` - `path: String` - `query: String` - `request_body_content_type: String` - `request_body_template: String` These are only used when the request method is a POST, PUT, or PATCH - `tool_name: String` The tool name (commonly an "operation id" in OpenAPI specs) to call on the HTTP adapter. This is used to match the tool spec to the correct endpoint on the HTTP adapter. it will be derived from the name of the tool if not provided. - `mcp: ConfigMcp` - `tool_description: String` - `tool_name: String` - `tool_title: String` - `openapi: ConfigOpenAPI` - `method_: String` - `operation_id: String` - `path: String`